using System;

public class Resource : IDisposable {
  public Resource() {
    Console.WriteLine("Created");
  }
  
  public void operation() {
    Console.WriteLine("do some work");
  }
  
  ~Resource() {
    Console.WriteLine("destroyed");
  }
  
  public void Dispose() {
    Console.WriteLine("destroyed!");
    GC.SuppressFinalize(this);
  }
  
  public static void Main(string[] args) {
    //You must remember to use the using construct if you want quick cleanup of the instance
    //not desirable.
    using(Resource resource = new Resource()) {
      resource.operation();      
    }
    
    Console.WriteLine("end of main");
  }
}