using System;

public class Resource : IDisposable {
  private Resource() {
    Console.WriteLine("Created");
  }
  
  public void operation() {
    Console.WriteLine("do some work");
  }
  
  ~Resource() {
    Console.WriteLine("destroyed");
  }
  
  public void Dispose() {
    Console.WriteLine("destroyed!");
    GC.SuppressFinalize(this);
  }
  
  public delegate void ResourceUser(Resource resource);
  
  public static void use(ResourceUser user) {
    using(Resource resource = new Resource()) {
      user(resource);
    }
  }
  
  public static void Main(string[] args) {
    Resource.use(delegate(Resource resource) {
      resource.operation();
    });
    
    Console.WriteLine("end of main");
  }
}