using System;

public class Resource : IDisposable {
  private Resource() {
    Console.WriteLine("Created");
  }
  
  public void operation() {
    Console.WriteLine("do some work");
  }
  
  ~Resource() {
    Console.WriteLine("destroyed");
  }
  
  public void Dispose() {
    Console.WriteLine("destroyed!");
    GC.SuppressFinalize(this);
  }
  
  public static void use(Action<Resource> action) {
    using(Resource resource = new Resource()) {
      action(resource);
    }
  }
  
  public static void Main(string[] args) {
    Resource.use((Resource resource) => resource.operation());
    
    Console.WriteLine("end of main");
  }
}